package plugin.sympathy.rss.views.tree;

import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import plugin.sympathy.rss.util.ExceptionHandler;

import de.nava.informa.core.ItemIF;

public class DoubleClickListener implements IDoubleClickListener {

	private Composite _parent;
	
	public DoubleClickListener(Composite _parent)
	{
		this._parent = _parent;
	}
	
	public void doubleClick(DoubleClickEvent event) 
	{
		ItemIF item = (ItemIF)((StructuredSelection) event.getSelection()).getFirstElement();
		
		try 
		{
			PlatformUI.getWorkbench().getBrowserSupport().createBrowser("SymRSS").openURL(item.getLink());
		}
		catch (PartInitException e) 
		{
			new ExceptionHandler().exceptionHandlar(e, this._parent.getShell());
			e.printStackTrace();
		}
	}

}
